## amarok 3.0.1

=== debian/changelog ===
amarok (2:3.0.1-1ubuntu5) oracular; urgency=medium

  * No-change rebuild against Qt 5.15.15.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 14 Sep 2024 11:14:28 +0300

amarok (2:3.0.1-1ubuntu4) oracular; urgency=medium

  * Rebuild against new libavcodec61.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 17:09:01 +0200

amarok (2:3.0.1-1ubuntu3) oracular; urgency=medium

  * Rebuild against new mariadb 11.4.2-2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 04 Jul 2024 16:09:04 +0200

amarok (2:3.0.1-1ubuntu2) oracular; urgency=medium

  * Rebuild against new mariadb 11.4.2-2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 04 Jul 2024 13:54:59 +0200

amarok (2:3.0.1-1ubuntu1) oracular; urgency=medium

  * Adapt Debian package for Ubuntu:
    - Add epoch "2:" to the version number
    - depend on default-libmysqld-dev | libmariadbd-dev
      (Ubuntu's version of mysql-defaults does not build default-libmysqld-dev)
    - depend on default-libmysqlclient-dev (>= 1.0.2~) | libmariadb-dev-compat
      (otherwise libmariadb-dev conflicts with libmysqlclient-dev)

 -- Maia Everett <maia@everett.one>  Thu, 06 Jun 2024 00:32:15 +0300

amarok (3.0.1-1) experimental; urgency=medium

  * New upstream release.
  * Update path in watch file; switch to version 4.
  * Update the patches:
    - debian_mysqle_amarok_local_errmsg_feature.diff: port to Qt5
    - debian_find_mysql_fix.diff: drop, as mysql_config_pic has not been
      shipped in years
    - debian_clamz_is_runtime_dependency.diff: drop, as amzdownloader was
      dropped
    - valgrind_uninitialized_value: refresh/update
    - no-mp3tunes.diff: drop, as the mp3tunes service is disabled upstream now
    - use-secrure-URLs.diff: drop, fixed upstream
  * Update the build dependencies following the port to Frameworks:
    - remove libqtwebkit-dev, libqt4-opengl-dev, kdelibs5-dev, libqjson-dev,
      libqca2-dev, and liblastfm-dev
    - add qtbase5-dev, qttools5-dev, qtdeclarative5-dev, libqt5svg5-dev,
      qtquickcontrols2-5-dev, qtwebengine5-dev, libphonon4qt5-dev,
      libphonon4qt5experimental-dev, extra-cmake-modules, libkf5archive-dev,
      libkf5attica-dev, libkf5codecs-dev, libkf5config-dev,
      libkf5configwidgets-dev, libkf5coreaddons-dev, libkf5crash-dev,
      libkf5dbusaddons-dev, libkf5declarative-dev, libkf5dnssd-dev,
      libkf5doctools-dev, libkf5globalaccel-dev, libkf5guiaddons-dev,
      libkf5i18n-dev, libkf5iconthemes-dev, libkf5kcmutils-dev, libkf5kio-dev,
      libkf5newstuff-dev, libkf5notifications-dev, libkf5package-dev,
      libkf5solid-dev, libkf5texteditor-dev, libkf5threadweaver-dev,
      libkf5wallet-dev, libkf5widgetsaddons-dev, libkf5windowsystem-dev,
      kirigami2-dev, libqca-qt5-2-dev, and liblastfm5-dev
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16
    - bump libtag1-dev to 1.12
    - add libmygpo-qt-dev, as it can be used without issues now
    - add dh-exec, for architecture-specific bits in install files
    - replace libgtk2.0-dev with libgdk-pixbuf-2.0-dev
    - explicitly add gettext, pkgconf, and python3:any
    - drop libtag-extras-dev, as it is no more available in Debian
    - drop libcurl4-gnutls-dev, libxml2-dev, libloudmouth1-dev, and
      libgcrypt20-dev, as mp3tunes is disabled
    - drop libwrap0-dev, and libaio-dev, no more needed
  * Use the right dh addon:
    - add the dh-sequence-kf5 build dependency to use the kf5 addon
      automatically, removing pkg-kde-tools
    - drop all the manually specified addons and buildsystem for dh
    - stop using the kde addon
  * Switch the cmake parameter -DKDE4_BUILD_TESTS=false to the KF5 equivalent,
    -DBUILD_TESTING=false.
  * Update install files.
  * Switch /usr/share/kde4/apps/amarok/mysqle references to
    /usr/share/amarok/mysqle.
  * Drop the libqtscript4-core, libqtscript4-gui, libqtscript4-network,
    libqtscript4-xml, libqtscript4-sql, and libqtscript4-uitools dependencies,
    as they are no more needed (Qt5 Declarative is used).
  * amzdownloader was dropped, so:
    - drop the clamz recommend from amarok
    - stop mentioning it in the description of amarok-utils
  * Switch the libqt4-sql-sqlite, libqt4-sql-mysql, and libqt4-sql-psql suggests
    to their Qt5 counterparts, i.e. libqt5sql5-sqlite, libqt5sql5-mysql, and
    libqt5sql5-psql.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper build dependency to debhelper-compat 13
    - remove debian/compat
    - stop passing --fail-missing to dh_missing, as it is the default
  * Add Rules-Requires-Root: no.
  * Add the configuration for the CI on salsa.
  * Bump Standards-Version to 4.7.0, no changes required.
  * Update lintian overrides.
  * Drop all the locally provided man pages: either they refer to tools that
    do not exist anymore, or they are terribly outdated.
  * Drop removal of COPYING files, as they are no more installed.
  * Use execute_after_dh_auto_install to avoid invoking dh_auto_install
    manually.
  * Use execute_after_dh_install-indep to avoid invoking dh_install manually,
    and to remove the manual check for arch:all packages being built.
  * Drop breaks/replaces for versions older than Jessie (current oldoldstable).
  * Update the bug control file to request the status of phonon4qt5-backend
    instead of phonon-backend.
  * Extend debian_mysqle_amarok_local_errmsg_feature.diff to load translated
    errmsg.sys files as well: add a Python script to copy not only the English
    errmsg.sys, but also all the available (at this time) translation errmsg.sys
    files
    - drop amarok-common.dirs, as all the needed directories are created by the
      copying script
  * Rewrite copyright to copyright-format v1.0, and massively update it.
  * Drop the migration from amarok-dbg, no more needed anymore at this point.
  * Remove inactive Uploaders, adding myself as one to avoid leaving the source
    with no human maintainers.


=== debian/control ===
Source: amarok
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-exec,
 dh-sequence-kf5,
 cmake (>= 3.16~),
 gettext,
 pkgconf,
 python3:any,
 libtag1-dev (>= 1.12~),
 qtbase5-dev (>= 5.15.0~),
 qttools5-dev (>= 5.15.0~),
 qtdeclarative5-dev (>= 5.15.0~),
 libqt5svg5-dev (>= 5.15.0~),
 qtquickcontrols2-5-dev (>= 5.15.0~),
 qtwebengine5-dev (>= 5.15.0~) [amd64 arm64 armhf i386],
 libphonon4qt5-dev,
 libphonon4qt5experimental-dev,
 extra-cmake-modules (>= 5.78.0~),
 libkf5archive-dev (>= 5.78.0~),
 libkf5attica-dev (>= 5.78.0~),
 libkf5codecs-dev (>= 5.78.0~),
 libkf5config-dev (>= 5.78.0~),
 libkf5configwidgets-dev (>= 5.78.0~),
 libkf5coreaddons-dev (>= 5.78.0~),
 libkf5crash-dev (>= 5.78.0~),
 libkf5dbusaddons-dev (>= 5.78.0~),
 libkf5declarative-dev (>= 5.78.0~),
 libkf5dnssd-dev (>= 5.78.0~),
 libkf5doctools-dev (>= 5.78.0~),
 libkf5globalaccel-dev (>= 5.78.0~),
 libkf5guiaddons-dev (>= 5.78.0~),
 libkf5i18n-dev (>= 5.78.0~),
 libkf5iconthemes-dev (>= 5.78.0~),
 libkf5kcmutils-dev (>= 5.78.0~),
 libkf5kio-dev (>= 5.78.0~),
 libkf5newstuff-dev (>= 5.78.0~),
 libkf5notifications-dev (>= 5.78.0~),
 libkf5package-dev (>= 5.78.0~),
 libkf5solid-dev (>= 5.78.0~),
 libkf5texteditor-dev (>= 5.78.0~),
 libkf5threadweaver-dev (>= 5.78.0~),
 libkf5wallet-dev (>= 5.78.0~),
 libkf5widgetsaddons-dev (>= 5.78.0~),
 libkf5windowsystem-dev (>= 5.78.0~),
 kirigami2-dev,
 libmtp-dev (>= 1.0.0),
 libglib2.0-dev, libgpod-dev (>= 0.7.0),
 default-libmysqld-dev | libmariadbd-dev, default-libmysqlclient-dev (>= 1.0.2~) | libmariadb-dev-compat,
 libqca-qt5-2-dev, liblastfm5-dev (>= 1.0.3),
 libavformat-dev (>= 4:0.5), libofa0-dev,
 libmygpo-qt-dev,
 libgdk-pixbuf-2.0-dev,
Build-Depends-Indep: default-mysql-server-core (>= 1.0.2~) | virtual-mysql-server-core
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://amarok.kde.org
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/amarok.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/amarok

Package: amarok
Architecture: any
Depends: amarok-common (= ${source:Version}), amarok-utils (= ${binary:Version}),
 qml-module-org-kde-kirigami2 (>= 5.15.0~),
 qml-module-qtqml-models2 (>= 5.15.0~),
 qml-module-qtquick-controls2 (>= 5.15.0~),
 qml-module-qtquick-dialogs (>= 5.15.0~),
 qml-module-qtquick-layouts (>= 5.15.0~),
 qml-module-qtquick2 (>= 5.15.0~),
 qml-module-qtwebengine (>= 5.15.0~) [amd64 arm64 armhf i386],
 ${shlibs:Depends}, ${misc:Depends},
Recommends: kio-audiocd,
Suggests: amarok-doc (>= ${source:Version}), libqt5sql5-sqlite, libqt5sql5-mysql, libqt5sql5-psql,
 moodbar
Description: easy to use media player based on the KDE Platform
 Amarok is a powerful music player with an intuitive interface. It makes
 playing the music you love and discovering new music easier than ever before
 and it looks good doing it! Amarok is based on the powerful Qt4 / KDE4
 Platform and nicely integrates with KDE desktop.
 .
 Much work has been invested into integrating Amarok 2 with various Web
 services:
   - Ampache
   - Jamendo Service
   - Last.fm
   - Librivox
   - MP3tunes
   - Magnatune
   - OPML Podcast Directory
 .
 Amarok comes with a lot of features including but not limited to:
   - Scripts - enhance your Amarok experience with community developed scripts.
   - Dynamic Playlists - create playlists that automatically update.
   - Context View - customize interface with the Plasma powered Context View.
   - PopUp Dropper - simplify drag&drop actions with revolutionary menu system.
   - Multiple Language Translations
   - Collection Management - organizing your music collection has never been
     easier with Amarok's powerful tagging, renaming, and sorting abilities.
   - Database Importing - import collections from Amarok 1.4 or iTunes.
   - Scriptable Services - integrate other web services into Amarok.

Package: amarok-common
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: amarok (>= ${source:Version})
Description: architecture independent files for Amarok
 This package contains architecture independent files needed for Amarok to run
 properly. Therefore, unless you have 'amarok' package of the same version
 installed, you will hardly find this package useful.
 .
 Amarok is a powerful music player with an intuitive interface.

Package: amarok-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: amarok (>= ${source:Version}), khelpcenter
Description: Amarok documentation (Handbook)
 This package contains Amarok user documentation in various languages. It can be
 opened from the application menu Help -> Amarok Handbook.
 .
 Amarok is a powerful music player with an intuitive interface.

Package: amarok-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: utilities for Amarok media player
 This package contains command line utilities that are typically used by Amarok
 media player but might also be useful on systems without Amarok installed.
 They are designed to be lightweight as they do not depend on KDE libraries.
 .
 Currently the package contains the following utilities:
   - amarokcollectionscanner - scans audio files, collects information from
     file tags and prints it in the structured XML format.
   - amarok_afttagger - a helper program which writes/removes custom tags
     to/from media files required for embedded "Amarok File Tracking".

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=false

override_dh_bugfiles:
	dh_bugfiles -A

execute_after_dh_install-indep:
	# Copy errmsg.sys files from mysql-server-core package
	debian/copy-errmsg-files.py /usr/share/mysql debian/amarok-common/usr/share/amarok/mysqle

execute_after_dh_auto_install:
	# Remove development stuff
	find debian/tmp -name '*.so' -type l -print -delete

%:
	dh $@

.PHONY: override_dh_auto_test

## amarok 3.1.0

=== debian/changelog ===
amarok (3.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - debian_mysqle_amarok_local_errmsg_feature.diff: refresh, and adapt to the
      new upstream code
  * Update the build dependencies according to the upstream build system:
    - bump KF packages to 5.89.0
    - drop no more needed libkf5attica-dev, and libkf5newstuff-dev
  * Update install files.
  * Drop no more needed ${perl:Depends} substvar from amarok-common.
  * Update copyright.

 -- Pino Toscano <pino@debian.org>  Sun, 04 Aug 2024 08:03:17 +0200

amarok (3.0.1-3) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * Depend directly on libmariadbd-dev.
  * Update package contents to be compatible with MariaDB 11.4.

 -- Pino Toscano <pino@debian.org>  Tue, 16 Jul 2024 22:35:40 +0200

amarok (3.0.1-2) unstable; urgency=medium

  * Upload to unstable.
  * Update debian/README.Debian a bit, notably:
    - drop references to URLs, features, and files not available anymore
    - update the Phonon section a bit to the current way to configure it;
      the feature availability still needs to be reviewed, though

 -- Pino Toscano <pino@debian.org>  Fri, 21 Jun 2024 07:25:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: amarok
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
+Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: debhelper-compat (= 13),
  dh-exec,
@@ -20,42 +19,40 @@
  qtwebengine5-dev (>= 5.15.0~) [amd64 arm64 armhf i386],
  libphonon4qt5-dev,
  libphonon4qt5experimental-dev,
- extra-cmake-modules (>= 5.78.0~),
- libkf5archive-dev (>= 5.78.0~),
- libkf5attica-dev (>= 5.78.0~),
- libkf5codecs-dev (>= 5.78.0~),
- libkf5config-dev (>= 5.78.0~),
- libkf5configwidgets-dev (>= 5.78.0~),
- libkf5coreaddons-dev (>= 5.78.0~),
- libkf5crash-dev (>= 5.78.0~),
- libkf5dbusaddons-dev (>= 5.78.0~),
- libkf5declarative-dev (>= 5.78.0~),
- libkf5dnssd-dev (>= 5.78.0~),
- libkf5doctools-dev (>= 5.78.0~),
- libkf5globalaccel-dev (>= 5.78.0~),
- libkf5guiaddons-dev (>= 5.78.0~),
- libkf5i18n-dev (>= 5.78.0~),
- libkf5iconthemes-dev (>= 5.78.0~),
- libkf5kcmutils-dev (>= 5.78.0~),
- libkf5kio-dev (>= 5.78.0~),
- libkf5newstuff-dev (>= 5.78.0~),
- libkf5notifications-dev (>= 5.78.0~),
- libkf5package-dev (>= 5.78.0~),
- libkf5solid-dev (>= 5.78.0~),
- libkf5texteditor-dev (>= 5.78.0~),
- libkf5threadweaver-dev (>= 5.78.0~),
- libkf5wallet-dev (>= 5.78.0~),
- libkf5widgetsaddons-dev (>= 5.78.0~),
- libkf5windowsystem-dev (>= 5.78.0~),
+ extra-cmake-modules (>= 5.89.0~),
+ libkf5archive-dev (>= 5.89.0~),
+ libkf5codecs-dev (>= 5.89.0~),
+ libkf5config-dev (>= 5.89.0~),
+ libkf5configwidgets-dev (>= 5.89.0~),
+ libkf5coreaddons-dev (>= 5.89.0~),
+ libkf5crash-dev (>= 5.89.0~),
+ libkf5dbusaddons-dev (>= 5.89.0~),
+ libkf5declarative-dev (>= 5.89.0~),
+ libkf5dnssd-dev (>= 5.89.0~),
+ libkf5doctools-dev (>= 5.89.0~),
+ libkf5globalaccel-dev (>= 5.89.0~),
+ libkf5guiaddons-dev (>= 5.89.0~),
+ libkf5i18n-dev (>= 5.89.0~),
+ libkf5iconthemes-dev (>= 5.89.0~),
+ libkf5kcmutils-dev (>= 5.89.0~),
+ libkf5kio-dev (>= 5.89.0~),
+ libkf5notifications-dev (>= 5.89.0~),
+ libkf5package-dev (>= 5.89.0~),
+ libkf5solid-dev (>= 5.89.0~),
+ libkf5texteditor-dev (>= 5.89.0~),
+ libkf5threadweaver-dev (>= 5.89.0~),
+ libkf5wallet-dev (>= 5.89.0~),
+ libkf5widgetsaddons-dev (>= 5.89.0~),
+ libkf5windowsystem-dev (>= 5.89.0~),
  kirigami2-dev,
  libmtp-dev (>= 1.0.0),
  libglib2.0-dev, libgpod-dev (>= 0.7.0),
- default-libmysqld-dev | libmariadbd-dev, default-libmysqlclient-dev (>= 1.0.2~) | libmariadb-dev-compat,
+ libmariadbd-dev, libmariadb-dev,
  libqca-qt5-2-dev, liblastfm5-dev (>= 1.0.3),
  libavformat-dev (>= 4:0.5), libofa0-dev,
  libmygpo-qt-dev,
  libgdk-pixbuf-2.0-dev,
-Build-Depends-Indep: default-mysql-server-core (>= 1.0.2~) | virtual-mysql-server-core
+Build-Depends-Indep: mariadb-server-core
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://amarok.kde.org
@@ -105,7 +102,7 @@
 
 Package: amarok-common
 Architecture: all
-Depends: ${misc:Depends}, ${perl:Depends}
+Depends: ${misc:Depends},
 Recommends: amarok (>= ${source:Version})
 Description: architecture independent files for Amarok
  This package contains architecture independent files needed for Amarok to run

## amarok 3.1.1

=== debian/changelog ===
amarok (3.1.1-2) unstable; urgency=medium

  * Team upload.
  * Rebuild against taglib 2.0.2.
  * debian/control: Update build-dependency package name:
    + libtag1-dev => libtag-dev.

 -- Boyuan Yang <byang@debian.org>  Fri, 10 Jan 2025 21:53:04 -0500

amarok (3.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - add libkf5textwidgets-dev
    - drop libkf5declarative-dev, no more used

 -- Pino Toscano <pino@debian.org>  Mon, 30 Sep 2024 08:04:30 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  gettext,
  pkgconf,
  python3:any,
- libtag1-dev (>= 1.12~),
+ libtag-dev (>= 1.12~),
  qtbase5-dev (>= 5.15.0~),
  qttools5-dev (>= 5.15.0~),
  qtdeclarative5-dev (>= 5.15.0~),
@@ -27,7 +27,6 @@
  libkf5coreaddons-dev (>= 5.89.0~),
  libkf5crash-dev (>= 5.89.0~),
  libkf5dbusaddons-dev (>= 5.89.0~),
- libkf5declarative-dev (>= 5.89.0~),
  libkf5dnssd-dev (>= 5.89.0~),
  libkf5doctools-dev (>= 5.89.0~),
  libkf5globalaccel-dev (>= 5.89.0~),
@@ -40,6 +39,7 @@
  libkf5package-dev (>= 5.89.0~),
  libkf5solid-dev (>= 5.89.0~),
  libkf5texteditor-dev (>= 5.89.0~),
+ libkf5textwidgets-dev (>= 5.89.0~),
  libkf5threadweaver-dev (>= 5.89.0~),
  libkf5wallet-dev (>= 5.89.0~),
  libkf5widgetsaddons-dev (>= 5.89.0~),

## amarok 3.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(Amarok)

###############

if(BUILD_WITH_QT6)
  message(STATUS "Trying to build Qt6 version")
  set(KF_MIN_VERSION "6.0.0")
  set(KF_MAJOR_VERSION "6")
  set(QT_MIN_VERSION "6.1.0")
  set(QT_MAJOR_VERSION "6")
else()
  message(STATUS "Building good old Qt5 version")
  set(KF_MIN_VERSION "5.108.0")
  set(KF_MAJOR_VERSION "5")
  set(QT_MIN_VERSION "5.15.0")
  set(QT_MAJOR_VERSION "5")
endif()
find_package(PkgConfig REQUIRED)
find_package(ECM ${KF_MIN_VERSION} REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
#include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMAddAppIcon)
include(ECMPoQmTools)
include(FindPkgConfig)
include(CMakePushCheckState)
include(GenerateExportHeader)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED COMPONENTS Core DBus Gui QuickWidgets Qml Sql Svg Test Widgets Xml)

find_package(Qt${QT_MAJOR_VERSION}QuickControls2 ${QT_MIN_VERSION})
set_package_properties(Qt${QT_MAJOR_VERSION}QuickControls2 PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")


if(BUILD_WITH_QT6)
  find_package(Qt${QT_MAJOR_VERSION}Core5Compat ${QT_MIN_VERSION} REQUIRED)
  find_package(Qt${QT_MAJOR_VERSION}SvgWidgets ${QT_MIN_VERSION} REQUIRED)
  find_package(Qt${QT_MAJOR_VERSION}WebEngineWidgets ${QT_MIN_VERSION})
  set_package_properties(Qt${QT_MAJOR_VERSION}WebEngineWidgets PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the wikipedia applet")
else()
  find_package(Qt${QT_MAJOR_VERSION}WebEngine ${QT_MIN_VERSION})
  set_package_properties(Qt${QT_MAJOR_VERSION}WebEngine PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the wikipedia applet")
endif()

find_package(Qt${QT_MAJOR_VERSION}UiTools ${QT_MIN_VERSION})
set_package_properties(Qt${QT_MAJOR_VERSION}UiTools PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the scripting engine")

find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Codecs
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    DNSSD
    DocTools
    GlobalAccel
    GuiAddons
    I18n
    IconThemes
    KCMUtils
    KIO
    Notifications
    Package
    Solid
    TextEditor
    TextWidgets
    ThreadWeaver
    WidgetsAddons
    WindowSystem
)

if(BUILD_WITH_QT6)
  find_package(KF${KF_MAJOR_VERSION}ColorScheme ${KF_MIN_VERSION} REQUIRED)
  find_package(KF${KF_MAJOR_VERSION}KCMUtils ${KF_MIN_VERSION} REQUIRED)
  find_package(KF${KF_MAJOR_VERSION}StatusNotifierItem ${KF_MIN_VERSION} REQUIRED)
  find_package(KF${KF_MAJOR_VERSION}Kirigami ${KF_MIN_VERSION})
  set_package_properties(KF${KF_MAJOR_VERSION}Kirigami PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")
else()
  find_package(KF${KF_MAJOR_VERSION}Kirigami2 ${KF_MIN_VERSION})
  set_package_properties(KF${KF_MAJOR_VERSION}Kirigami2 PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")
endif()


###############
option(WITH_UTILITIES "Enable building of utilities" ON)
option(WITH_PLAYER "Enable building of main Amarok player" ON)
# option(WITH_MP3Tunes "Enable mp3tunes in the Amarok player, requires multiple extra dependencies" ON) #build is disabled for now, no need to show option
option(WITH_GPODDER "Enable gpodder.net support" ON)
option(WITH_IPOD "Enable iPod support in Amarok" ON)
option(WITH_LASTFM "Enable last.fm support" ON)

############### Taglib
set(TAGLIB_MIN_VERSION "1.12")
find_package(Taglib REQUIRED)
set_package_properties( Taglib PROPERTIES DESCRIPTION "Support for Audio metadata." URL "https://taglib.org/" TYPE REQUIRED PURPOSE "Required for tag reading" )

# Check if TagLib is built with ASF and MP4 support
include(CheckCXXSourceCompiles)
cmake_push_check_state()
set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDES}")
set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")

check_cxx_source_compiles("#include <asftag.h>
int main() { TagLib::ASF::Tag tag; return 0;}" TAGLIB_ASF_FOUND)
if( NOT TAGLIB_ASF_FOUND )
    message(FATAL_ERROR "TagLib does not have ASF support compiled in.")
endif()

check_cxx_source_compiles("#include <mp4tag.h>
int main() { TagLib::MP4::Tag tag(0, 0); return 0;}" TAGLIB_MP4_FOUND)
if( NOT TAGLIB_MP4_FOUND )
    message(FATAL_ERROR "TagLib does not have MP4 support compiled in.")
endif()

check_cxx_source_compiles("#include <modtag.h>
#include <modfile.h>
#include <s3mfile.h>
#include <itfile.h>
#include <xmfile.h>
using namespace TagLib;
int main() { char *s; Mod::Tag tag; Mod::File modfile(s); S3M::File s3mfile(s);
IT::File itfile(s); XM::File xmfile(s); return 0; }" TAGLIB_MOD_FOUND)

check_cxx_source_compiles("#include <opusfile.h>
int main() { char *s; TagLib::Ogg::Opus::File opusfile(s); return 0;}" TAGLIB_OPUS_FOUND)
cmake_pop_check_state()

set(TAGLIB-EXTRAS_MIN_VERSION "1.0")
find_package(Taglib-Extras)
set_package_properties(Taglib-Extras PROPERTIES DESCRIPTION "Support for metadata reading of RealMedia and Audible file types" URL "https://websvn.kde.org/trunk/kdesupport/taglib-extras/" TYPE OPTIONAL )
set(TAGLIB_EXTRAS_FOUND ${TAGLIB-EXTRAS_FOUND}) # we need a c-compatible name for the include file

include(CheckTagLibFileName)

check_taglib_filename(COMPLEX_TAGLIB_FILENAME)
###############


#Needed to conditionally build tests and gui
find_package(Googlemock)
set_package_properties( GOOGLEMOCK PROPERTIES DESCRIPTION "Used in Amarok's tests." URL "https://github.com/google/googlemock" TYPE OPTIONAL )

if(NOT GOOGLEMOCK_FOUND)
    set(BUILD_TESTING OFF)
endif()

if(BUILD_TESTING)
   add_definitions(-DDEBUG)
endif()

if(WITH_DESKTOP_UI)
    add_definitions(-DDESKTOP_UI)
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fmessage-length=0")
if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fmessage-length=0")
    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-needed")
    endif()
endif ()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/shared
    ${CMAKE_CURRENT_BINARY_DIR}/shared
)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# WORKAROUND for Clang bug: http://llvm.org/bugs/show_bug.cgi?id=15651
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-delayed-template-parsing")
endif ()

####################################################################################
# CMAKE_AUTOMOC

if(NOT CMAKE_VERSION VERSION_LESS "3.10.0")
    # CMake 3.9+ warns about automoc on files without Q_OBJECT, and doesn't know about other macros.
    # 3.10+ lets us provide more macro names that require automoc.
    list(APPEND CMAKE_AUTOMOC_MACRO_NAMES AMAROK_EXPORT_SIMPLE_IMPORTER_PLUGIN)
endif()

add_definitions(-DQT_NO_URL_CAST_FROM_STRING -DQT_NO_CAST_TO_ASCII)

find_package(Phonon4Qt${QT_MAJOR_VERSION} 4.6.60 REQUIRED NO_MODULE)
add_definitions(-DPHONON_LIB_SONAME=\"${PHONON_LIB_SONAME}\")

if( WITH_LASTFM )
    find_package( LibLastFm )
    set( LIBLASTFM_MIN_VERSION "1.0.0" )
    if( LIBLASTFM_FOUND )
        if ( ${LIBLASTFM_MIN_VERSION} VERSION_LESS ${LIBLASTFM_VERSION} )
            set( LIBLASTFM_FOUND TRUE )
        endif()
    endif()
endif()

string( TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER )
if( CMAKE_BUILD_TYPE_TOLOWER MATCHES debug )
    set( DEBUG_BUILD_TYPE ON )
    add_definitions(-Wall -Wextra)
endif()

add_subdirectory( data )
add_subdirectory( images )

if( WITH_PLAYER )
    find_package(Threads REQUIRED)

    find_package(MySQL)

    if( NOT MySQL_FOUND )
        find_package(MariaDB REQUIRED)
    endif()

    find_package(MySQLe)
    if( MySQLe_FOUND )
        set( BUILD_MYSQLE_COLLECTION TRUE )
        # zlib is required for mysql embedded
        find_package(ZLIB REQUIRED)
        set_package_properties( ZLIB PROPERTIES DESCRIPTION "zlib" TYPE REQUIRED )
    else()
        add_definitions( "-DNO_MYSQL_EMBEDDED" )
    endif()

    # We tell users that we need 1.0.3, but we really check just >= 1.0.0. This is because
    # upstream forgot to update version in lastfm/global.h, so it looks like 1.0.2. :-(
    # will be fixed in liblastfm-1.0.4
    set( LIBLASTFM_MIN_VERSION "1.0.3" )
    set_package_properties( LibLastFm PROPERTIES DESCRIPTION "Enable Last.Fm service, including scrobbling, song submissions, and suggested song dynamic playlists" URL "http://cdn.last.fm/client/liblastfm-${LIBLASTFM_MIN_VERSION}.tar.gz" TYPE OPTIONAL )

    find_package(FFmpeg)
    set_package_properties(FFmpeg PROPERTIES
        DESCRIPTION "Libraries and tools for handling multimedia data"
        URL "https://www.ffmpeg.org/"
        TYPE OPTIONAL
        PURPOSE "Enable MusicDNS service"
    )

    find_package(LibOFA)
    set_package_properties(LibOFA PROPERTIES
        DESCRIPTION "Open-source audio fingerprint by MusicIP"
        URL "http://code.google.com/p/musicip-libofa/"
        TYPE OPTIONAL
        PURPOSE "Enable MusicDNS service"
    )

    if( WITH_GPODDER )
        ## gpodder Service
        if(BUILD_WITH_QT6)
            find_package(Mygpo-qt6 1.1.0 CONFIG)
            set_package_properties(Mygpo-qt6 PROPERTIES
                DESCRIPTION "A Qt/C++ library wrapping the gpodder.net Webservice."
                URL "http://wiki.gpodder.org/wiki/Libmygpo-qt"
                TYPE OPTIONAL
                PURPOSE "Synchronize podcast subscriptions with gpodder.net"
            )
        else()
            find_package(Mygpo-qt5 1.1.0 CONFIG)
            set_package_properties(Mygpo-qt5 PROPERTIES
                DESCRIPTION "A Qt/C++ library wrapping the gpodder.net Webservice."
                URL "http://wiki.gpodder.org/wiki/Libmygpo-qt"
                TYPE OPTIONAL
                PURPOSE "Synchronize podcast subscriptions with gpodder.net"
            )
        endif()
    endif()

    if( WITH_GPODDER OR WITH_LASTFM ) ## problems in their header files as of 07/2024, not compatible with strict flags
        remove_definitions(
            -DQT_NO_CAST_FROM_ASCII
            -DQT_NO_KEYWORDS
        )
    endif()

    if( WITH_IPOD )
        find_package(Ipod)
        set(IPOD_MIN_VERSION "0.8.2")
        if( IPOD_FOUND AND NOT WIN32 )
            if ( ${IPOD_MIN_VERSION} VERSION_LESS ${IPOD_VERSION} )
                set( IPOD_FOUND TRUE )
            endif()
        endif()
        set_package_properties( Ipod PROPERTIES DESCRIPTION "Support Apple iPod/iPad/iPhone audio devices" URL "http://sourceforge.net/projects/gtkpod/" TYPE OPTIONAL )
        find_package(GDKPixBuf)
        set_package_properties( GDKPixBuf PROPERTIES DESCRIPTION "Support for artwork on iPod audio devices via GDK-PixBuf" URL "http://developer.gnome.org/arch/imaging/gdkpixbuf.html" TYPE OPTIONAL )
    endif()

    find_package(Mtp 1.0.0)
    set_package_properties(Mtp PROPERTIES
        TYPE OPTIONAL
        PURPOSE "Enable Support for portable media devices that use the media transfer protocol"
    )

    if( WITH_MP3Tunes )
        find_package(CURL)
        set_package_properties( CURL PROPERTIES DESCRIPTION "Used to transfer data with URLs" URL "https://curl.haxx.se/" TYPE OPTIONAL )

        find_package(LibXml2)
        set_package_properties( LibXml2 PROPERTIES DESCRIPTION "LibXML2 is an XML parser required by mp3tunes." URL "http://www.xmlsoft.org" TYPE OPTIONAL )

        find_package(OpenSSL)
        find_package(Libgcrypt)
        if ( OPENSSL_FOUND OR LIBGCRYPT_FOUND )
            set (_mp3tunes_crypto TRUE )
        else ()
            message( SEND_ERROR "Building with mp3tunes support REQUIRES either OpenSSL or GNU Libgcrypt" )
        endif ()
        set_package_properties( OpenSSL PROPERTIES DESCRIPTION "OpenSSL or GNU Libgcrypt provides cryptographic functions required by mp3tunes." URL "http://www.openssl.org/ or http://www.gnupg.org/download/#libgcrypt" TYPE OPTIONAL )

=== debian/changelog ===
amarok (3.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump KF packages to 5.108.0
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Tue, 04 Feb 2025 20:15:12 +0100
